diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index d52cefa96..05c78e1eb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -7,12 +7,12 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import org.lwjgl.opengl.GL11;
 
 public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
 {
+    private final RenderBlocks blockRenderer;
 
     public EntityRendererTNT()
     {
@@ -20,15 +20,14 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
         shadowSize = 0.5F;
     }
 
-    public void renderTNT(EntityPrimedTNT tnt, double d, double d1, double d2,
-                          float f, float f1)
+    @Override
+    public void render(Tessellator tessellator, EntityPrimedTNT tnt, double x, double y, double z, float yaw, float partialTick)
     {
-        Tessellator tessellator = Tessellator.instance;
         GL11.glPushMatrix();
-        GL11.glTranslatef((float)d, (float)d1, (float)d2);
-        if(((float)tnt.fuse - f1) + 1.0F < 10F)
+        GL11.glTranslatef((float)x, (float)y, (float)z);
+        if(((float)tnt.fuse - partialTick) + 1.0F < 10F)
         {
-            float f2 = 1.0F - (((float)tnt.fuse - f1) + 1.0F) / 10F;
+            float f2 = 1.0F - (((float)tnt.fuse - partialTick) + 1.0F) / 10F;
             if(f2 < 0.0F)
             {
                 f2 = 0.0F;
@@ -42,11 +41,12 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
             float f4 = 1.0F + f2 * 0.3F;
             GL11.glScalef(f4, f4, f4);
         }
-        float f3 = (1.0F - (((float)tnt.fuse - f1) + 1.0F) / 100F) * 0.8F;
+        float f3 = (1.0F - (((float)tnt.fuse - partialTick) + 1.0F) / 100F) * 0.8F;
         TextureRegistry.blockAtlas.bind();
-        float brightness = tnt.getBrightness(f1);
+        float brightness = tnt.getBrightness(partialTick);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
+        BlockModel.setRenderBlocks(blockRenderer);
+        BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
         model.renderBlockOnInventory(tessellator, 0, brightness, null);
         if((tnt.fuse / 5) % 2 == 0)
         {
@@ -63,13 +63,4 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
         }
         GL11.glPopMatrix();
     }
-
-    @Override
-    public void render(Tessellator tessellator, EntityPrimedTNT entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        renderTNT(entity, x, y, z, yaw, partialTick);
-    }
-
-    private final RenderBlocks blockRenderer;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 62f74377c..097660555 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -23,7 +23,6 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.*;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.BlocksContainer;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index 676d11172..cedcbb1d5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -4,7 +4,6 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelWolf;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.MobWolf;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index b9c141f32..1c28468c1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -30,9 +30,9 @@ import java.util.Random;
 import static org.lwjgl.opengl.GL11.*;
 
 public class ItemModelBlock extends ItemModelStandard {
-    private Block block;
-    private BlockModel<Block> blockModel;
-    public ItemModelBlock(ItemBlock itemBlock){
+    private Block<?> block;
+    private BlockModel<?> blockModel;
+    public ItemModelBlock(ItemBlock<?> itemBlock){
         super(itemBlock, null);
         this.block = itemBlock.getBlock();
         this.blockModel = BlockModelDispatcher.getInstance().getDispatch(block);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 815954ff4..fdc7a9ff0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.util.dispatch.Dispatcher;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
@@ -222,20 +221,20 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.RECORD_WAIT, "minecraft"));
         addDispatch(new ItemModelStandard(Items.RECORD_DOG, "minecraft"));
 
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.TORCH_COAL.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.TORCH_REDSTONE_ACTIVE.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.GLOWSTONE.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.PUMPKIN_CARVED_ACTIVE.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.LAMP_ACTIVE.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.PORTAL_PARADISE.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock) Blocks.PORTAL_NETHER.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.TORCH_COAL.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.TORCH_REDSTONE_ACTIVE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.GLOWSTONE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PUMPKIN_CARVED_ACTIVE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.LAMP_ACTIVE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_PARADISE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_NETHER.asItem()).setFullBright());
 
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
             Item item = Blocks.blocksList[i].asItem();
             if (dispatches.containsKey(item)) continue;
             if (!(item instanceof ItemBlock)) continue;
-            addDispatch(new ItemModelBlock((ItemBlock) item));
+            addDispatch(new ItemModelBlock((ItemBlock<?>) item));
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
index fd05ffae4..f70129a94 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
@@ -77,7 +77,7 @@ public abstract class Shaders {
 		shader.uniformInt("cbCorrectionMode", minecraft.gameSettings.colorblindnessFix.value.ordinal());
 
 		ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
-		shader.uniformInt("shaderEffect", helmet != null && helmet.itemID == Blocks.PUMPKIN_REDSTONE.id ? 1 : 0);
+		shader.uniformInt("shaderEffect", helmet != null && helmet.itemID == Blocks.PUMPKIN_REDSTONE.id() ? 1 : 0);
 
 		int isEyeInLiquid = 0;
 		float celestialAngle = 0.0f;
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index ef4d0cb97..e7d7fdca4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -8,12 +8,10 @@ import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
-import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.entity.EntityRendererItem;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
index 2bb384149..b203a5574 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
@@ -14,7 +14,6 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
diff --git a/game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java b/game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
index 2793bc73a..1ae877411 100644
--- a/game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
+++ b/game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
@@ -22,7 +22,7 @@ public class BTAComplexChunk implements Chunk {
 
     @Override
     public int getBlockColor(ChunkPos3D pos) {
-        Block b = Blocks.getBlock(chunk.getBlockID(pos.x, pos.y, pos.z));
+        Block<?> b = Blocks.getBlock(chunk.getBlockID(pos.x, pos.y, pos.z));
         if (b == null) return 0;
         int meta = chunk.getBlockMetadata(pos.x, pos.y, pos.z);
         return MaterialColor.getColorFromIndex(MaterialColor.getColorIndexFromBlock(b, meta)) | 0xFF_00_00_00;
@@ -40,9 +40,9 @@ public class BTAComplexChunk implements Chunk {
         while (true) {
             int y = start - depth;
             if (y < 0) break;
-            Block b = Blocks.getBlock(chunk.getBlockID(pos.x, y, pos.z));
+            Block<?> b = Blocks.getBlock(chunk.getBlockID(pos.x, y, pos.z));
             if (b == null) break;
-            if (b.blockMaterial != Material.water) break;
+            if (b.getMaterial() != Material.water) break;
             depth++;
         }
         return depth;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 5976a3e3a..04ba1e808 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -1,41 +1,26 @@
 package net.minecraft.core.block;
 
-
-import java.util.ArrayList;
-import java.util.Random;
-import java.util.function.Function;
-import java.util.function.Supplier;
-
-import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.support.FullSupport;
-import net.minecraft.core.block.support.ISupport;
-import net.minecraft.core.entity.EntityFallingBlock;
-import net.minecraft.core.util.helper.Direction;
-import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
-
 import net.minecraft.core.achievement.stat.Stat;
-import net.minecraft.core.achievement.stat.StatList;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
-import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.tool.ItemToolShears;
 import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.BlockSounds;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
@@ -43,141 +28,148 @@ import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-public class Block
-    implements ITaggable<Block>, IItemConvertible
-{
-    public final int id;
-    public final NamespaceID namespaceID;
-    protected float blockHardness;
-    protected float blastResistance;
-    protected boolean blockConstructorCalled;
-    protected boolean enableStats;
-    protected boolean isLitInteriorSurface;
-    protected final AABB bounds = AABB.getPermanentBB(0, 0, 0, 1, 1, 1);
+import java.util.ArrayList;
+import java.util.Objects;
+import java.util.Random;
+import java.util.function.Function;
+import java.util.function.Supplier;
+
+public final class Block<T extends BlockLogic>
+    implements ITaggable<Block<?>>, IItemConvertible, BlockInterface {
+    public static boolean disableNormalEntityLogic = false;
+
+    private final int id;
+    private final @NotNull String key;
+    private final @NotNull NamespaceID namespaceID;
+    private final @NotNull BlockLogicSupplier<T> logicSupplier;
+    private T logic;
+
+    public float blockHardness;
+    public float blastResistance;
+    public boolean enableStats;
+    public boolean isLitInteriorSurface;
     public float blockParticleGravity;
-    public final Material blockMaterial;
     public float friction;
-    protected String key;
+    public int emission;
+    public int lightBlock;
     public boolean immovable = false;
+    public boolean isEntityTile = false;
+    public boolean disabledNeighborMetaNotify = false;
+    public boolean shouldTick = false;
+    public @Nullable Supplier<TileEntity> entitySupplier;
     public MaterialColor overrideColor;
     private BlockSound blockSound = BlockSounds.DEFAULT;
-
+    @NotNull public Supplier<Item> blockItemSupplier = () -> new ItemBlock<>(this);
     @Nullable
     Supplier<@NotNull IItemConvertible> statParent = null;
 
+    Block(int id, @NotNull String translationKey, @NotNull String namespaceId, @NotNull BlockLogicSupplier<T> logicSupplier) {
+        this.namespaceID = setupNamespaceId(namespaceId);
+        this.key = setupTranslationKey(translationKey);
+        this.id = setupNumericId(id);
+
+        this.logicSupplier = Objects.requireNonNull(logicSupplier);
 
-	public Block(String translationKey, String namespaceId, int id, Material material)
-    {
-        blockConstructorCalled = true;
         enableStats = true;
         blockParticleGravity = 1.0F;
         friction = 0.6F;
         immovable = false;
-        this.id = id;
-        try {
-            this.namespaceID = new NamespaceID(namespaceId);
-        } catch (HardIllegalArgumentException e){
-            throw new IllegalArgumentException(e);
+    }
+
+    private int setupNumericId(int id) {
+        if (id < 0) {
+            throw new IllegalArgumentException("Numeric id of block '" + namespaceID + "' must not be negative!");
+        }
+        if (id >= Blocks.blocksList.length) {
+            throw new IllegalArgumentException("Numeric id of block '" + namespaceID + "' must not be greater than '" + (Blocks.blocksList.length - 1) + "'!");
         }
+        return id;
+    }
 
-        if(Blocks.blocksList[id] != null) {
-            throw new IllegalArgumentException("Block slot '" + id + "' is already occupied by '" + Blocks.blocksList[id] + "' when adding " + this);
+    private @NotNull String setupTranslationKey(String translationKey) {
+        if (translationKey == null) {
+            throw new NullPointerException("Translation key of block '" + namespaceID + "' must not be null!");
         }
-        if (Blocks.blockMap.containsKey(this.namespaceID)){
-            throw new IllegalArgumentException("Block id '" + namespaceID + "' is already used by '" + Blocks.blockMap.get(this.namespaceID) + "' when adding " + this);
+        if (!translationKey.startsWith("tile.")) {
+            translationKey = "tile." + translationKey;
         }
+        return translationKey;
+    }
 
-        blockMaterial = material;
-        Blocks.blocksList[id] = this;
-        Blocks.blockMap.put(this.namespaceID, this);
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-        Blocks.solid[id] = isSolidRender();
-        Blocks.lightBlock[id] = (isSolidRender() || blocksLight()) ? 255 : 0;
-        Blocks.translucent[id] = !material.blocksLight();
-        Blocks.isEntityTile[id] = false;
-        this.key = "tile." + translationKey;
-        Blocks.keyToIdMap.put(this.key, this.id);
+    private @NotNull NamespaceID setupNamespaceId(String namespaceId) {
+        if (namespaceId == null) {
+            throw new NullPointerException("NamespaceId must not be null!");
+        }
+        if (!namespaceId.contains(":")) {
+            namespaceId = "minecraft:" + namespaceId;
+        }
+//        String[] parts = namespaceId.split(":");
+//        if (parts.length != 2) throw new IllegalArgumentException("NamespaceId '" + namespaceId + "' contains more then 1 ':' character!");
+//        if (!parts[1].startsWith("block/")) {
+//            namespaceId = parts[0] + ":" + "block/" + parts[1];
+//        }
+        try {
+            return new NamespaceID(namespaceId);
+        } catch (HardIllegalArgumentException e) {
+            throw new RuntimeException(e);
+        }
+    }
 
-        if (Blocks.highestBlockId < id) Blocks.highestBlockId = id;
+    public T getLogic() {
+        return logic;
     }
 
-	public Block withDisabledNeighborNotifyOnMetadataChange()
-    {
-        Blocks.neighborNotifyOnMetadataChangeDisabled[id] = true;
+    public Block<T> withEntity(@Nullable Supplier<TileEntity> entitySupplier) {
+        this.isEntityTile = true;
+        this.entitySupplier = entitySupplier;
         return this;
     }
 
-    protected void initializeBlock()
+    public Block<T> withDisabledNeighborNotifyOnMetadataChange()
     {
+        disabledNeighborMetaNotify = true;
+        return this;
     }
 
-    public Block withLightBlock(int blockAmount)
+    public Block<T> withLightBlock(int blockAmount)
     {
-        Blocks.lightBlock[id] = blockAmount;
+        lightBlock = blockAmount;
         return this;
     }
-    public Block withLightEmission(float lightEmission)
+    public Block<T> withLightEmission(float lightEmission)
     {
-        Blocks.lightEmission[id] = (int)(15F * lightEmission);
+        this.emission = (int)(15F * lightEmission);
         return this;
     }
 
-    public Block withLightEmission(int lightEmission)
+    public Block<T> withLightEmission(int lightEmission)
     {
-        Blocks.lightEmission[id] = lightEmission & 0x0F;
+        this.emission = lightEmission & 0x0F;
         return this;
     }
 
-    public Block withImmovableFlagSet()
+    public Block<T> withImmovableFlagSet()
     {
         this.immovable = true;
         return this;
     }
 
-    public Block withBlastResistance(float blastResistance)
+    public Block<T> withBlastResistance(float blastResistance)
     {
         this.blastResistance = blastResistance * 3F;
         return this;
     }
 
-    public Block withSound(BlockSound sound)
+    public Block<T> withSound(BlockSound sound)
     {
         this.blockSound = sound;
         return this;
     }
 
-    public BlockSound getSound()
-    {
-        return blockSound;
-    }
-
-    public boolean isCubeShaped()
-    {
-        return true;
-    }
-
-    public boolean canPlaceOnSurface()
-    {
-        return this.isCubeShaped();
-    }
-
-    public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z)
-    {
-        return this.canPlaceOnSurface();
-    }
-
-    public boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z)
-    {
-        return isCubeShaped();
-    }
-
-    public boolean canPlaceOnSurfaceOfBlock(World world, int x, int y, int z)
-    {
-        return canPlaceOnSurface();
-    }
-
-    public Block withHardness(float blockHardness)
+    public Block<T> withHardness(float blockHardness)
     {
         this.blockHardness = blockHardness;
         if(blastResistance < blockHardness * 5F)
